Input Events Feeding Functions

Functions
Input Events Feeding Functions
Evas » Canvas Functions » Canvas Events

Functions to tell Evas that input events happened and should be processed. More...

## Functions
Evas_Device * | evas_device_add (Evas *e)
| Add a new device type. More...
void | evas_device_del (Evas_Device *dev)
| Delete a new device type. More...
void | evas_device_push (Evas *e, Evas_Device *dev)
| Push the current context device onto the device stack. More...
void | evas_device_pop (Evas *e)
| This pops the top of the device stack for the canvas. More...
const Eina_List * | evas_device_list (Evas *e, const Evas_Device *dev)
| List all current devices attached to the given canvas and/or device. More...
void | evas_device_name_set (Evas_Device *dev, const char *name)
| Set the name of a device as a string. More...
const char * | evas_device_name_get (const Evas_Device *dev)
| Get the name of a device. More...
void | evas_device_description_set (Evas_Device *dev, const char *desc)
| Set the description of a device as a string. More...
const char * | evas_device_description_get (const Evas_Device *dev)
| Get the description of a device. More...
void | evas_device_parent_set (Evas_Device *dev, Evas_Device *parent)
| Set the parent of a device. More...
const Evas_Device * | evas_device_parent_get (const Evas_Device *dev)
| Get the parent of a device. More...
void | evas_device_class_set (Evas_Device *dev, Evas_Device_Class clas)
| Set the major class of device. More...
Evas_Device_Class | evas_device_class_get (const Evas_Device *dev)
| Get the major class of a device. More...
void | evas_device_subclass_set (Evas_Device *dev, Evas_Device_Subclass clas)
| Set the sub-class of a device. More...
Evas_Device_Subclass | evas_device_subclass_get (const Evas_Device *dev)
| Get the device sub-class. More...
void | evas_device_emulation_source_set (Evas_Device *dev, Evas_Device *src)
| Set the emulation source device. More...
const Evas_Device * | evas_device_emulation_source_get (const Evas_Device *dev)
| Get the emulation source device. More...
void | evas_event_freeze (Evas *e)
| Freeze all input events processing. More...
void | evas_event_thaw (Evas *e)
| Thaw a canvas out after freezing (for input events). More...
int | evas_event_freeze_get (const Evas *e)
| Return the freeze count on input events of a given canvas. More...
void | evas_event_thaw_eval (Evas *e)
| After thaw of a canvas, re-evaluate the state of objects and call callbacks. More...

## Detailed Description

Functions to tell Evas that input events happened and should be processed.

Warning
  Most of the time these functions are not what you're looking for. These functions should only be used if you're not working with ecore evas(or another input handling system). If you're not using ecore evas please consider using it, in most situation it will make life a lot easier.

As explained in intro_not_evas, Evas does not know how to poll for input events, so the developer should do it and then feed such events to the canvas to be processed. This is only required if operating Evas directly. Modules such as Ecore_Evas do that for you.

Some of the functions in this group are exemplified here.

## Function Documentation

## ◆ evas_device_add()

Evas_Device* evas_device_add | ( | Evas * | e | ) |

Add a new device type.

Parameters

  e | The canvas to create the device node for.

Adds a new device node to the given canvas `e`. All devices created as part of the canvas `e` will automatically be deleted when the canvas is freed.

Returns
  the device node created or NULL if an error occurred.

See also
  evas_device_del

Since
  1.8

References eina_list_append(), eo_data_scope_get(), and EVAS_CALLBACK_DEVICE_CHANGED.

## ◆ evas_device_del()

void evas_device_del | ( | Evas_Device * | dev | ) |

Delete a new device type.

Parameters

  dev | The device node you want to delete.

See also
  evas_device_add
  evas_device_push
  evas_device_pop

Since
  1.8

References EINA_LIST_FREE, and evas_device_del().

Referenced by evas_device_del(), and evas_device_emulation_source_get().

## ◆ evas_device_push()

void evas_device_push | ( | Evas * | e,
|  | Evas_Device * | dev
| ) |  |

Push the current context device onto the device stack.

Parameters

  e | The canvas to push the device on to
  dev | The device to push.

This pushes the given device `dev` onto the stack for the canvas `e` resulting in the dev pointer in all events that get fed to the canvas being the device at the top of the device stack for that canvas.

If a device is pushed onto the device stack, it will not be deleted until a canvas free OR until it has been popped from the stack even if evas_device_del() is called.

The device `dev` must have been created as a device for the canvas it is pushed onto (and not another canvas).

Example:

evas_device_push(canvas, dev);
evas_event_feed_mouse_move(canvas, 20, 30, 0, NULL);
evas_device_pop(canvas);

See also
  evas_device_pop

Since
  1.8

References eina_array_new(), eina_array_push(), and eo_data_scope_get().

## ◆ evas_device_pop()

void evas_device_pop | ( | Evas * | e | ) |

This pops the top of the device stack for the canvas.

Parameters

  e | The canvas to pop the device stack from

This pops the top of the device stack making the current device context used for device events being what is now at the top of the stack after popping.

See also
  evas_device_push

Since
  1.8

References eina_array_pop(), and eo_data_scope_get().

## ◆ evas_device_list()

const Eina_List* evas_device_list | ( | Evas * | e,
|  | const Evas_Device * | dev
| ) |  |

List all current devices attached to the given canvas and/or device.

Parameters

  e | The canvas to query for a device list
  dev | A specific device inside the canvas to query for child devices or NULL if just querying the base canvas devices

Returns
  An internal list of Evas_Device pointers, or NULL if no devices are found

This will list all devices belonging to a specific evas canvas `e`, at the top-level in the device tree if `dev` passed in is NULL. If `dev` is a valid device for the given canvas `e`, then a list of child devices of `dev` will be returned, allowing you to walk the device tree.

The list returned is only valid so long as no changes are made to the device tree in the given canvas `e`. If there are no devices or children then NULL is returned.

See also
  evas_device_parent_get
  evas_device_name_get
  evas_device_description_get
  evas_device_class_get
  evas_device_subclass_get
  evas_device_emulation_source_get

Since
  1.8

References eo_data_scope_get().

## ◆ evas_device_name_set()

void evas_device_name_set | ( | Evas_Device * | dev,
|  | const char * | name
| ) |  |

Set the name of a device as a string.

`dev` The device to set the name of `name` The name string as a readable C UTF8 string

Since
  1.8

## ◆ evas_device_name_get()

const char* evas_device_name_get | ( | const Evas_Device * | dev | ) |

Get the name of a device.

`dev` The device to query

Returns
  The device name string or NULL if none is set

This gets the name set by evas_device_name_set(). This is a readable UTF8 C string, or NULL if no name is set.

The name should be a short name like "Wireless Mouse", "Joystick", "Finger", "Keyboard" or "Numberpad" etc.

Since
  1.8

Referenced by ecore_imf_evas_event_key_down_wrap(), and ecore_imf_evas_event_key_up_wrap().

## ◆ evas_device_description_set()

void evas_device_description_set | ( | Evas_Device * | dev,
|  | const char * | desc
| ) |  |

Set the description of a device as a string.

`dev` The device to set the description of `name` The description string as a readable C UTF8 string

Since
  1.8

## ◆ evas_device_description_get()

const char* evas_device_description_get | ( | const Evas_Device * | dev | ) |

Get the description of a device.

`dev` The device to query

Returns
  The device description string or NULL if none is set

This gets the description set by evas_device_description_set(). This is a readable UTF8 C string, or NULL if no description is set.

A description is meant to be a longer string describing the device so a human may make sense of it. For example "Wireless 6 button mouse in Black with red buttons" would be a good description, so a user may identify precisely which device is being talked about.

Since
  1.8

## ◆ evas_device_parent_set()

void evas_device_parent_set | ( | Evas_Device * | dev,
|  | Evas_Device * | parent
| ) |  |

Set the parent of a device.

`dev` The device to set the parent of `parent` The new parent device

This sets the parent of a device `dev` to the parent given by `parent`. If the device already has a parent, it is removed from that parent's list. If `parent` is NULL then the device is unparented and placed back as a root device in the canvas.

When a device is deleted with evas_device_del(), all children are also deleted along with it.

See also
  evas_device_del
  evas_device_parent_get
  evas_device_list

Since
  1.8

References eina_list_append(), eina_list_remove(), eo_data_scope_get(), EVAS_CALLBACK_DEVICE_CHANGED, and efl::eo::parent.

## ◆ evas_device_parent_get()

const Evas_Device* evas_device_parent_get | ( | const Evas_Device * | dev | ) |

Get the parent of a device.

Parameters

  dev | The device to query

Returns
  The parent device or NULL if it is a toplevel

This returns the parent device of any given device entry, or NULL if no parent device exists (is a toplevel device).

Since
  1.8

## ◆ evas_device_class_set()

void evas_device_class_set | ( | Evas_Device * | dev,
|  | Evas_Device_Class | clas
| ) |  |

Set the major class of device.

Parameters

  dev | The device whose class to set
  clas | The class to set it to

This sets the "primary" class of device (a broad thing like mouse, keyboard, touch, pen etc.).

Since
  1.8

References EVAS_CALLBACK_DEVICE_CHANGED.

## ◆ evas_device_class_get()

Evas_Device_Class evas_device_class_get | ( | const Evas_Device * | dev | ) |

Get the major class of a device.

Parameters

  dev | The devise to query

Returns
  The device class to set

This sets the device class set by evas_device_class_set().

Since
  1.8

References EVAS_DEVICE_CLASS_NONE.

Referenced by ecore_imf_evas_event_key_down_wrap(), and ecore_imf_evas_event_key_up_wrap().

## ◆ evas_device_subclass_set()

void evas_device_subclass_set | ( | Evas_Device * | dev,
|  | Evas_Device_Subclass | clas
| ) |  |

Set the sub-class of a device.

Parameters

  dev | The device to modify
  clas | The sub-class to set

This sets the sub-class of a device which gives much more detailed usage within a broader category.

Since
  1.8

References EVAS_CALLBACK_DEVICE_CHANGED.

## ◆ evas_device_subclass_get()

Evas_Device_Subclass evas_device_subclass_get | ( | const Evas_Device * | dev | ) |

Get the device sub-class.

Parameters

  dev | The device to query

Returns
  The device sub-class set by evas_device_subclass_set().

Since
  1.8

References EVAS_DEVICE_SUBCLASS_NONE.

Referenced by ecore_imf_evas_event_key_down_wrap(), and ecore_imf_evas_event_key_up_wrap().

## ◆ evas_device_emulation_source_set()

void evas_device_emulation_source_set | ( | Evas_Device * | dev,
|  | Evas_Device * | src
| ) |  |

Set the emulation source device.

Parameters

  dev | The device being emulated
  src | The primary source device producing events in the emulated device

Devices may not be real, but may be emulated by listening to input on other devices and modifying or interpeting it to generate output on an emulated device (example a fingeron a touchscreen will often emulate a mouse when it presses). This allows you to set which device primarily emulates `dev` so the user can choose to ignore events from emulated devices if they also pay attention to source device events for example.

Since
  1.8

References EVAS_CALLBACK_DEVICE_CHANGED.

## ◆ evas_device_emulation_source_get()

const Evas_Device* evas_device_emulation_source_get | ( | const Evas_Device * | dev | ) |

Get the emulation source device.

Parameters

  dev | The device to query

Returns
  The source emulation device set by evas_device_emulation_source_set().

Since
  1.8

References eina_array_count(), eina_array_data_get(), eina_array_free(), eina_array_pop(), EINA_LIST_FREE, eina_stringshare_del(), eo_data_scope_get(), and evas_device_del().

## ◆ evas_event_freeze()

void evas_event_freeze | ( | Evas * | e | ) |

Freeze all input events processing.

Parameters

  e | The canvas to freeze input events processing on.

This function will indicate to Evas that the canvas `e` is to have all input event processing frozen until a matching evas_event_thaw() function is called on the same canvas. All events of this kind during the freeze will get discarded. Every freeze call must be matched by a thaw call in order to completely thaw out a canvas (i.e. these calls may be nested). The most common use is when you don't want the user to interact with your user interface when you're populating a view or changing the layout.

Example:

"\tf - freeze input for 3 seconds\n"
"\tp - toggle precise point collision detection on image\n"
"\tControl + o - add an obscured rectangle\n"
"\th - print help\n";
struct test_data
{
Ecore_Evas *ee;
Evas *canvas;
Evas_Object *img, *bg;
Ecore_Timer *resize_timer, *freeze_timer;
Eina_Bool obscured, focus;
};
/* let's have our events back */
static Eina_Bool
_thaw_cb(void *data EINA_UNUSED)
{
fprintf(stdout, "Canvas was frozen %d times, now thawing.\n",
evas_event_freeze_get(d.canvas));
evas_event_thaw(d.canvas);
return EINA_FALSE; /* do not re-issue the timer */
}

See the full example.

If you run that example, you'll see the canvas ignoring all input events for 3 seconds, when the "f" key is pressed. In a more realistic code we would be freezing while a toolkit or Edje was doing some UI changes, thawing it back afterwards.

## ◆ evas_event_thaw()

void evas_event_thaw | ( | Evas * | e | ) |

Thaw a canvas out after freezing (for input events).

Parameters

  e | The canvas to thaw out.

This will thaw out a canvas after a matching evas_event_freeze() call. If this call completely thaws out a canvas, i.e., there's no other unbalanced call to evas_event_freeze(), events will start to be processed again, but any "missed" events will not be evaluated.

See evas_event_freeze() for an example.

Examples:
  evas-events.c.

## ◆ evas_event_freeze_get()

int evas_event_freeze_get | ( | const Evas * | e | ) |

Return the freeze count on input events of a given canvas.

Parameters

  e | The canvas to fetch the freeze count from.

This returns the number of times the canvas has been told to freeze input events. It is possible to call evas_event_freeze() multiple times, and these must be matched by evas_event_thaw() calls. This call allows the program to discover just how many times things have been frozen in case it may want to break out of a deep freeze state where the count is high.

Example:

extern Evas *evas;
while (evas_event_freeze_get(evas) > 0) evas_event_thaw(evas);

Examples:
  evas-events.c.

Referenced by evas_event_thaw_eval().

## ◆ evas_event_thaw_eval()

void evas_event_thaw_eval | ( | Evas * | e | ) |

After thaw of a canvas, re-evaluate the state of objects and call callbacks.

Parameters

  e | The canvas to evaluate after a thaw

This is normally called after evas_event_thaw() to re-evaluate mouse containment and other states and thus also call callbacks for mouse in and out on new objects if the state change demands it.

References _Evas_Event_Mouse_Down::button, _Evas_Event_Mouse_Down::canvas, EINA_LIST_FOREACH, eina_list_free(), eo_data_scope_get(), evas_event_freeze_get(), _Evas_Event_Mouse_Down::flags, INF, _Evas_Event_Mouse_Down::modifiers, _Evas_Event_Mouse_Down::output, _Evas_Coord_Point::x, _Evas_Point::x, _Evas_Coord_Point::y, and _Evas_Point::y.